package cn.emay.ql.demo;

import android.graphics.Typeface;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.geetest.onelogin.OneLoginHelper;
import com.geetest.onelogin.config.OneLoginThemeConfig;

import cn.emay.ql.uniloginsdk.UniSDK;
import cn.emay.ql.uniloginsdk.listeners.LoginCallback;

public class LansActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_lans);
        boolean type = getIntent().getExtras().getBoolean("type");
        login(type);
    }

    private void login(boolean isDialogStyle){
        UniSDK.getInstance().login(getThemeconfig(isDialogStyle), new LoginCallback() {
            @Override
            public void onSuccess(String msg) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(LansActivity.this, "登录成功：" + msg, Toast.LENGTH_SHORT).show();
                        OneLoginHelper.with().dismissAuthActivity();
                        finish();
                    }
                });
            }

            @Override
            public void onFailed(String msg) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(LansActivity.this, "登录失败：" + msg, Toast.LENGTH_SHORT).show();
                        OneLoginHelper.with().dismissAuthActivity();
                        finish();
                    }
                });
            }
        });
    }
    private OneLoginThemeConfig getThemeconfig(boolean isDialogStyle){
        return new OneLoginThemeConfig.Builder()
                .setDialogTheme(isDialogStyle,500,350,0,0,false,false)//弹窗模式设置
                .setStatusBar(0, 0, true)//状态字体颜色
                .setAuthBGImgPath("gt_one_login_bg")//授权页背景
                .setAuthNavLayout(0xFF3973FF, 50, true, false)//标题栏布局
                .setAuthNavTextView("免密登录", 0xFF333333, 17, false, "服务条款" ,0xFF000000, 17)//标题栏中间文字相关
                .setAuthNavReturnImgView("back", 20, 20, isDialogStyle, 8)//标题栏back按钮相关
                .setBlockReturnEvent(false, false)//屏蔽返回按钮
                .setLogoImgView("app_logo",80,80,false,45,0,0)//授权页logo
                .setNumberView(0xFF3D424C,22,75,0,0)//号码栏文字
                .setNumberText(null)//CharSequence numberText
                .setNumberViewTypeface(Typeface.DEFAULT)//字体
                .setSwitchView("切换账号",0xFF3973FF,14,true,249,0,0)//切换账号
                .setSwitchViewLayout("", 80,25)
                .setSwitchViewTypeface(Typeface.DEFAULT)
                // 一键登录背景支持配置带状态选择器 selector 的 drawable，配合 setLogBtnDisableIfUnChecked 接口可实现登录按钮状态随选择框选中状态切换
                .setLogBtnLayout("emay_login_bg", "emay_login_bg", 250, 45, 140, 0, 0)//登录按钮
                .setLogBtnTextView("一键登录", 0xFFFFFFFF, 18)
                .setLogBtnTextViewTypeface(Typeface.DEFAULT)
                .setLogBtnDisableIfUnChecked(false)//未勾选隐私协议时登录是否可点击
                .setLogBtnLoadingView(false ? "" : "umcsdk_load_dot_white", 20, 20, 12)//登录的loading
                .setSloganView(0xFFA8A8A8, 10, 200, 0, 0)//slogan
                .setSloganViewTypeface(Typeface.DEFAULT)
                .setPrivacyUnCheckedToastText("请先同意服务条款")//未勾选服务协议时点击登录的提示语
                .setPrivacyLayout(280, 0, 18, 0, true)//隐私条款布局
                .setPrivacyCheckBox("gt_one_login_unchecked", "gt_one_login_checked", false, 9, 9, 2)//勾选框样式
                .setPrivacyClauseView(0xff666666, 0xff0085d0, 12)//协议基础颜色、协议颜色
                .setPrivacyClauseViewTypeface(Typeface.defaultFromStyle(Typeface.BOLD), Typeface.defaultFromStyle(Typeface.NORMAL))
                // 预留一组条款，SDK 填充运营商隐私条款
                .setPrivacyClauseTextStrings("我已阅读并同意", "用户协议一", "https://www.baidu.com", "",
                        "和", "用户协议二", "https://www.hao123.com", "",
                        "和", "用户协议三", "https://www.zhihu.com/hot", "",
                        "和", "", "", "并使用本机号码登录")//协议内容及点击后的跳转链接
                .setPrivacyAddFrenchQuotes(true)//隐私条款是否显示书名号
                .setPrivacyTextGravity(Gravity.TOP|Gravity.START)
                .setPrivacyLineSpacing(0.8f, 1.0f)
                .build();
    }
}