package cn.emay.ql.demo;

import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import com.geetest.onelogin.OneLoginHelper;
import com.geetest.onelogin.config.AuthRegisterViewConfig;
import com.geetest.onelogin.config.OneLoginThemeConfig;
import com.geetest.onelogin.listener.CustomInterface;
import com.tencent.mm.opensdk.modelmsg.SendAuth;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;

import java.util.ArrayList;
import java.util.List;

import cn.emay.ql.uniloginsdk.UniSDK;

import cn.emay.ql.uniloginsdk.listeners.InitCallback;
import cn.emay.ql.uniloginsdk.listeners.LoginCallback;

public class MainActivity extends AppCompatActivity implements View.OnClickListener{
    private PermissionListener mListener;
    private static final int PERMISSION_REQUESTCODE = 100;
    Button tv_login;
    Button tv_login_dialog;
    Button tv_login_lans;
    Button tv_login_lans_dialog;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        tv_login = (Button) findViewById(R.id.tv_login);
        tv_login_dialog = (Button) findViewById(R.id.tv_login_dialog);
        tv_login_lans = (Button) findViewById(R.id.tv_login_lans) ;
        tv_login_lans_dialog = (Button) findViewById(R.id.tv_login_lans_dialog);
        tv_login_lans.setOnClickListener(this);
        tv_login_lans_dialog.setOnClickListener(this);
        tv_login.setOnClickListener(this);
        tv_login_dialog.setOnClickListener(this);
        requestPermission(this);
        UniSDK.getInstance().initAuth(this, "1462c43c1a31453bbaa39dbd949534f2", "32e7cd9f87de4d33", new InitCallback() {
            @Override
            public void onSuccess(String msg) {

            }

            @Override
            public void onFailed(String msg) {

            }
        });
        //注册微信
        registerWeixin();
    }
    /**
     * 定义的第三方登录设置
     */
    private void addCustomView(Activity mCntext) {
        LayoutInflater inflater1 = LayoutInflater.from(mCntext);
        RelativeLayout relativeLayout = (RelativeLayout) inflater1.inflate(R.layout.gt_demo_layout_other_login, null);
        RelativeLayout.LayoutParams layoutParamsOther = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
        layoutParamsOther.setMargins(0, DensityUtils.dip2px(mCntext, 380), 0, 0);
        layoutParamsOther.addRule(RelativeLayout.CENTER_HORIZONTAL);
        relativeLayout.setLayoutParams(layoutParamsOther);
        relativeLayout.findViewById(R.id.sms_login).setOnClickListener(v -> {
            Utils.toastMessage(mCntext, "短信验证登录");
        });
        relativeLayout.findViewById(R.id.weixin).setOnClickListener(v -> {
            Utils.toastMessage(mCntext, "微信登录");
            if(msgApi.isWXAppInstalled()){
                SendAuth.Req request = new SendAuth.Req();
                request.scope = "snsapi_userinfo";
                request.state = "wechat_sdk_demo_test_neng";
                msgApi.sendReq(request);
            }else{
                Toast.makeText(MainActivity.this,"微信未安装",Toast.LENGTH_SHORT).show();
            }
        });
        relativeLayout.findViewById(R.id.qq).setOnClickListener(v -> {
            Utils.toastMessage(mCntext, "qq登录");
        });
        relativeLayout.findViewById(R.id.weibo).setOnClickListener(v -> {
            Utils.toastMessage(mCntext, "微博登录");
        });
        /**
         * 添加自定义控件，addOneLoginRegisterViewConfig 调用多次可添加多个自定义控件，用不同的 id 区分
         * 注意添加的控件不要覆盖下面原有的控件，不然可能导致无法点击的问题
         */
        OneLoginHelper.with().addOneLoginRegisterViewConfig("title_button", new AuthRegisterViewConfig.Builder()
                .setView(relativeLayout)
                .setRootViewId(AuthRegisterViewConfig.RootViewId.ROOT_VIEW_ID_BODY)
//                .setCustomInterface(new CustomInterface() {
//                    @Override
//                    public void onClick(Context context) {
//                        Utils.toastMessage(context, "动态注册的其他按钮");
//                    }
//                })
                .build()
        );
    }

    private OneLoginThemeConfig getThemeconfig(boolean isDialogStyle){
        return new OneLoginThemeConfig.Builder()
                .setDialogTheme(isDialogStyle,300,500,0,0,false,false)//弹窗模式设置
                .setStatusBar(0, 0, true)//状态字体颜色
                .setAuthBGImgPath("gt_one_login_bg")//授权页背景
                .setAuthNavLayout(0xFF3973FF, 50, true, false)//标题栏布局
                .setAuthNavTextView("免密登录", 0xFF333333, 17, false, "服务条款" ,0xFF000000, 17)//标题栏中间文字相关
                .setAuthNavReturnImgView("back", 20, 20, isDialogStyle, 8)//标题栏back按钮相关
                .setBlockReturnEvent(false, false)//屏蔽返回按钮
                .setLogoImgView("app_logo",90,90,false,125,0,0)//授权页logo
                .setNumberView(0xFF3D424C,24,180,0,0)//号码栏文字
                .setNumberText(null)//CharSequence numberText
                .setNumberViewTypeface(Typeface.DEFAULT)//字体
                .setSwitchView("切换账号",0xFF3973FF,14,true,249,0,0)//切换账号
                .setSwitchViewLayout("", 80,25)
                .setSwitchViewTypeface(Typeface.DEFAULT)
                // 一键登录背景支持配置带状态选择器 selector 的 drawable，配合 setLogBtnDisableIfUnChecked 接口可实现登录按钮状态随选择框选中状态切换
                .setLogBtnLayout("emay_login_bg", "emay_login_bg", 250, 45, 240, 0, 0)//登录按钮
                .setLogBtnTextView("一键登录", 0xFFFFFFFF, 18)
                .setLogBtnTextViewTypeface(Typeface.DEFAULT)
                .setLogBtnDisableIfUnChecked(false)//未勾选隐私协议时登录是否可点击
                .setLogBtnLoadingView(false ? "" : "umcsdk_load_dot_white", 20, 20, 12)//登录的loading
                .setSloganView(0xFFA8A8A8, 10, 300, 0, 0)//slogan
                .setSloganViewTypeface(Typeface.DEFAULT)
                .setPrivacyUnCheckedToastText("请先同意服务条款")//未勾选服务协议时点击登录的提示语
                .setPrivacyLayout(280, 0, 18, 0, true)//隐私条款布局
                .setPrivacyCheckBox("gt_one_login_unchecked", "gt_one_login_checked", false, 9, 9, 2)//勾选框样式
                .setPrivacyClauseView(0xff666666, 0xff0085d0, 12)//协议基础颜色、协议颜色
                .setPrivacyClauseViewTypeface(Typeface.defaultFromStyle(Typeface.BOLD), Typeface.defaultFromStyle(Typeface.NORMAL))
                // 预留一组条款，SDK 填充运营商隐私条款
                .setPrivacyClauseTextStrings("我已阅读并同意", "用户协议一", "https://www.baidu.com", "",
                        "和", "用户协议二", "https://www.hao123.com", "",
                        "和", "用户协议三", "https://www.zhihu.com/hot", "",
                        "和", "", "", "并使用本机号码登录")//协议内容及点击后的跳转链接
                .setPrivacyAddFrenchQuotes(true)//隐私条款是否显示书名号
                .setPrivacyTextGravity(Gravity.TOP|Gravity.START)
                .setPrivacyLineSpacing(0.8f, 1.0f)
                .build();
    }
    private void login(boolean isDialogStyle){
        UniSDK.getInstance().login(getThemeconfig(isDialogStyle), new LoginCallback() {
            @Override
            public void onSuccess(String msg) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(MainActivity.this, "登录成功：" + msg, Toast.LENGTH_SHORT).show();
                        OneLoginHelper.with().dismissAuthActivity();
                    }
                });
            }

            @Override
            public void onFailed(String msg) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Toast.makeText(MainActivity.this, "登录失败：" + msg, Toast.LENGTH_SHORT).show();
                        OneLoginHelper.with().dismissAuthActivity();
                    }
                });
            }
        });
    }
    private void requestPermission(Activity activity) {
        requestRunPermisssion(new String[]{Manifest.permission.READ_PHONE_STATE}, new PermissionListener() {
            @Override
            public void onGranted() {
                //表示所有权限都授权了

            }

            @Override
            public void onDenied(List<String> deniedPermission) {
                for (String permission : deniedPermission) {
                    Toast.makeText(MainActivity.this, "被拒绝的权限：" + permission, Toast.LENGTH_SHORT).show();
                }
            }
        });
    }


    private void requestRunPermisssion(String[] permissions, PermissionListener listener) {
        mListener = listener;
        List<String> permissionLists = new ArrayList<>();
        for (String permission : permissions) {
            if (ContextCompat.checkSelfPermission(this, permission) != PackageManager.PERMISSION_GRANTED) {
                permissionLists.add(permission);
            }
        }

        if (!permissionLists.isEmpty()) {
            ActivityCompat.requestPermissions(this, permissionLists.toArray(new String[permissionLists.size()]), PERMISSION_REQUESTCODE);
        } else {
            //表示全都授权了
            mListener.onGranted();
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        switch (requestCode) {
            case PERMISSION_REQUESTCODE:
                if (grantResults.length > 0) {
                    //存放没授权的权限
                    List<String> deniedPermissions = new ArrayList<>();
                    for (int i = 0; i < grantResults.length; i++) {
                        int grantResult = grantResults[i];
                        String permission = permissions[i];
                        if (grantResult != PackageManager.PERMISSION_GRANTED) {
                            deniedPermissions.add(permission);
                        }
                    }
                    if (deniedPermissions.isEmpty()) {
                        //说明都授权了
                        mListener.onGranted();
                    } else {
                        mListener.onDenied(deniedPermissions);
                    }
                }
                break;
            default:
                break;
        }
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.tv_login:
                //加载自定义控件和修改UI设置需要在调用登录方法之前
                addCustomView(this);
                login(false);
                break;
            case R.id.tv_login_dialog:
                //加载自定义控件和修改UI设置需要在调用登录方法之前
                login(true);
                break;
            case R.id.tv_login_lans:
                Intent intent = new Intent(MainActivity.this,LansActivity.class);
                intent.putExtra("type",false);
                startActivity(intent);
                break;
            case R.id.tv_login_lans_dialog:
                Intent intent1 = new Intent(MainActivity.this,LansActivity.class);
                intent1.putExtra("type",true);
                startActivity(intent1);
                break;
            default:
                break;
        }
    }

    /**
     * 已授权、未授权的接口回调
     */
    public interface PermissionListener {

        void onGranted();//已授权

        void onDenied(List<String> deniedPermission);//未授权

    }

    private IWXAPI msgApi;

    private void registerWeixin() {
        msgApi = WXAPIFactory.createWXAPI(this, "wxe7e0f1aba86cb4ce", true);
        msgApi.registerApp("wxe7e0f1aba86cb4ce");
    }
}