package cn.emay.ql.demo.wxapi;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

import com.tencent.mm.opensdk.constants.ConstantsAPI;
import com.tencent.mm.opensdk.modelbase.BaseReq;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.modelmsg.SendAuth;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.IWXAPIEventHandler;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;

public class WXEntryActivity extends Activity implements IWXAPIEventHandler {
    private IWXAPI api;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        api = WXAPIFactory.createWXAPI(this, null);
        api.handleIntent(getIntent(), this);
    }

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);
        setIntent(intent);
        api.handleIntent(intent, this);
    }

    @Override
    public void onReq(BaseReq req) {
    }

    @Override
    public void onResp(BaseResp resp) {

        if (resp.getType() == ConstantsAPI.COMMAND_SENDAUTH) {// 登陆
            Log.i(WXEntryActivity.class.getSimpleName(),
                    String.valueOf(resp.errCode) + ", " + resp.errStr);
            // 获取微信传回的code
            SendAuth.Resp authResp = (SendAuth.Resp) resp;
            String code = authResp.code;

            //注意，此code为用户换取 access_token 的 code，仅在 ErrCode 为 0 时有效
            //一般做法为客户端将此code回传给服务器，服务器通过微信接口获取access_token
            //参考https://developers.weixin.qq.com/doc/oplatform/Mobile_App/WeChat_Login/Development_Guide.html
            Toast.makeText(this,("登录结果 ：" + resp.errCode + " code :" + code), Toast.LENGTH_LONG).show();
            finish();
        }
    }

}